# <link>

Links files using `link.exe`, Microsoft's Incremental Linker.

This task is intended for version 7.00.9466 of `link.exe`.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
output | file | The output file. | True
options | string | Options to pass to the compiler. | False
pdbfile | file | A user-specified name for the program database (PDB) that the linker creates. The default file name for the PDB has the base name of the `output` and the extension .pdb. | False
failonerror | bool | Determines if task failure stops the build, or is just reported. The default is true. | False
if | bool | If true then the task will be executed; otherwise, skipped. The default is true. | False
timeout | int | The maximum amount of time the application is allowed to execute, expressed in milliseconds. Defaults to no time-out. | False
unless | bool | Opposite of `if`. If false then the task will be executed; otherwise, skipped. The default is false. | False
verbose | bool | Determines whether the task should report detailed build log messages. The default is false. | False

### Framework-configurable parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
exename | string | The name of the executable that should be used to launch the external program. | False
useruntimeengine | bool | Specifies whether the external program should be executed using a runtime engine, if configured. The default is false. | False

### Nested Elements:

#### <delayloaded>

Specified DLLs for delay loading.

#### </delayloaded>

#### <sources>

The list of files to combine into the output file.

#### </sources>

#### <libdirs>

The list of additional library directories to search.

#### </libdirs>

#### <modules>

Link the specified modules into this assembly.

#### </modules>

#### <embeddedresources>

Embed the specified resources into this assembly.

#### </embeddedresources>

#### <symbols>

Symbols to add to the symbol table.

##### <symbol>

Represents a symbol.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
name | string | The name of the symbol. | True
if | bool | If true then the element will be processed; otherwise, skipped. The default is true. | False
unless | bool | If true then the element will be skipped; otherwise, processed. The default is false. | False

##### </symbol>

#### </symbols>

#### <ignorelibraries>

Names of libraries that you want the linker to ignore when it resolves external references.

##### <library>

Represents a library.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
name | string | The name of the library. | True
if | bool | If true then the element will be processed; otherwise, skipped. The default is true. | False
unless | bool | If true then the element will be skipped; otherwise, processed. The default is false. | False

##### </library>

#### </ignorelibraries>

#### <arg>

The command-line arguments for the external program.

Represents a command-line argument.

### Parameters

Attribute | Type | Description | Required
--- | --- | --- | ---
dir | directory | The value for a directory-based command-line argument; will be replaced with the absolute path of the directory. | False
file | file | The name of a file as a single command-line argument; will be replaced with the absolute filename of the file. | False
if | bool | Indicates if the argument should be passed to the external program. If true then the argument will be passed; otherwise, skipped. The default is true. | False
line | string | List of command-line arguments; will be passed to the executable as is. | False
path | <path> | The value for a PATH-like command-line argument; you can use `:` or `;` as path separators and NAnt will convert it to the platform's local conventions, while resolving references to environment variables. | False
unless | bool | Indicates if the argument should not be passed to the external program. If false then the argument will be passed; otherwise, skipped. The default is false. | False
value | string | A single command-line argument; can contain space characters. | False

### Nested Elements:

#### <path>

Sets a single command-line argument and treats it like a PATH - ensures the right separator for the local platform is used.

#### </path>

### Examples

- A single command-line argument containing a space character.

      <arg value="-l -a" />

- Two separate command-line arguments.

      <arg line="-l -a" />

- A single command-line argument with the value `\dir;\dir2;\dir3` on DOS-based systems and `/dir:/dir2:/dir3` on Unix-like systems.

      <arg path="/dir;/dir2:\dir3" />

#### </arg>

### Examples

- Combine all object files in the current directory into `helloworld.exe`.

      <link output="helloworld.exe">
          <sources>
              <include name="*.obj" />
          </sources>
      </link>

### Requirements

Assembly: NAnt.VisualCppTasks (0.85.2478.0)